import JSBI from 'jsbi';
import { Token } from './entities/token';
export declare type BigintIsh = JSBI | number | string;
export declare const isApollo: string | undefined;
export declare const arthTokenListUrl = "https://v3.arthswap.org/tokenLists/arthswap.tokenlist.json";
export declare enum ChainId {
    MAINNET = 592,
    TESTNET = 81,
    ROCSTAR = 692,
    CANARY = 336
}
export declare const defaultChainId: number;
export declare enum TradeType {
    EXACT_INPUT = 0,
    EXACT_OUTPUT = 1
}
export declare enum Rounding {
    ROUND_DOWN = 0,
    ROUND_HALF_UP = 1,
    ROUND_UP = 2
}
export declare const FACTORY_ADDRESS_MAP: Record<number, string>;
export declare const INIT_CODE_HASH_MAP: Record<number, string>;
export declare const MINIMUM_LIQUIDITY: JSBI;
export declare const ZERO: JSBI;
export declare const ONE: JSBI;
export declare const TWO: JSBI;
export declare const THREE: JSBI;
export declare const FIVE: JSBI;
export declare const TEN: JSBI;
export declare const _100: JSBI;
export declare const _997: JSBI;
export declare const _1000: JSBI;
export declare const MaxUint256: JSBI;
export declare enum SolidityType {
    uint8 = "uint8",
    uint256 = "uint256"
}
export declare const SOLIDITY_TYPE_MAXIMA: {
    uint8: JSBI;
    uint256: JSBI;
};
export declare const WNATIVE: Record<number, Token>;
export declare const NATIVE: Record<number, {
    name: string;
    symbol: string;
    decimals: number;
}>;
declare type ChainTokenList = {
    readonly [chainId in ChainId]: Token[];
};
export declare const BASES_TO_CHECK_TRADES_AGAINST: ChainTokenList;
export declare const MULTICALL_NETWORKS: {
    [chainId in ChainId]: string;
};
export declare const MULTICALL_ABI: {
    inputs: {
        components: {
            name: string;
            type: string;
        }[];
        name: string;
        type: string;
    }[];
    name: string;
    outputs: {
        name: string;
        type: string;
    }[];
    stateMutability: string;
    type: string;
}[];
export {};
